unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, math;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Image1: TImage;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    papel  : TCanvas;

    procedure datos();
    procedure max_min();
    procedure escalas();
    procedure trazar();

  public
    { Public declarations }
    XX, YY   : array of single;
    ND,TX,TY : integer;
    mx,bx,
    my,by    : single;
    q1,q2    : single;
    xmi,ymi,
    xma,yma  : single;
    mar      : integer;

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// inicializacion
procedure TForm1.FormCreate(Sender: TObject);
begin
  papel := Image1.Canvas;
  TX := Image1.Width;
  TY := Image1.Height;
  // limpiar la hoja de dibujo
  papel.Rectangle(0,0,TX-1,TY-1);

  Memo1.Lines.Clear;

  mar := 8;
end;

// Trazar
procedure TForm1.Button2Click(Sender: TObject);
begin
  datos();
  max_min();
  escalas();
  trazar();
end;

// ver datos
procedure TForm1.Button1Click(Sender: TObject);
var
  k : integer;
  s1,s2  : string;
begin
  Memo1.Clear;

  with Memo1.lines do begin
    Add('N  = ' + IntToStr(ND));
    Add('V1 = ' + FloatToStr(q1));
    Add('V2 = ' + FloatToStr(q2));

    Add('');
    Add('   XX        YY' );
    for k := 0 to ND - 1 do begin
      s1 := Format('%7.2f', [ XX[k] ]);
      s2 := Format('%7.2f', [ YY[k] ]);
      Add(s1 + '  ' + s2 );
    end;
  end;

end;

// metodos de datos
procedure TForm1.datos();
var
  k     : integer;
  dq    : single;

  // funcion a graficar
  function fun(x:single): single;
  begin
    result := 5*sin(x);
  end;

begin
  ND := StrToInt(Edit1.Text);
  q1 := StrToFloat(Edit2.Text);
  q2 := StrToFloat(Edit3.Text);

  // incremento
  dq := (q2-q1)/(ND-1);
  // asignar memoria a los arreglos
  SetLength(XX,ND);
  SetLength(YY,ND);

  for k := 0 to ND - 1 do begin
    XX[k] := q1 + k*dq;
    YY[k] := fun(XX[k]);
  end;
end;

// Maximos y minimos
procedure TForm1.max_min();
var
  k  : integer;
begin
  xmi := XX[0]; xma := xmi;
  ymi := YY[0]; yma := ymi;

  // para usar las funciones MIN y MAX se requiere
  // la bilioteca math, que debe ser incluida en uses

  for k := 1 to ND - 1 do begin
    xmi := MIN(xmi,XX[k]);
    ymi := MIN(ymi,YY[k]);
    xma := MAX(xma,XX[k]);
    yma := MAX(yma,YY[k]);
  end;

end;

// Escalas
procedure TForm1.escalas();
begin
  mx := (TX-2*mar)/(xma-xmi);
  bx := mar - mx*xmi;

  my := (TY-2*mar)/(ymi-yma);
  by := mar - my*yma;
end;

// Trazar
procedure TForm1.trazar();
var
  k,xp,yp   : integer;
begin
  xp := ceil(mx*XX[0] + bx);
  yp := ceil(my*YY[0] + by);
  papel.MoveTo(xp,yp);

  for k := 1 to ND - 1 do begin
    xp := ceil(mx*XX[k] + bx);
    yp := ceil(my*YY[k] + by);
    papel.LineTo(xp,yp);
  end;
end;

end.
